import java.io.*;
import com.nokia.mid.ui.*;
import javax.microedition.lcdui.*;

class BoxCanvas
    extends FullCanvas
    implements Runnable, CommandListener
{
    private volatile Thread animationThread = null;
    private Font font;
    testMIDlet father;
    long fp_time_start=0,fp_time;
    int  fps=0, i = 0, stop=0, alpha=0;
    Image mirror=Image.createImage(48,128);
    Image eye   =Image.createImage(16,16);
    int points[] = new int[1059*3];
    int trian[] = new int[600*3];
    int pxy[] = new int[4*354]; 
    final int tr_count = 600;
    final int pt_count = 354;

    private int sin(int x)
    {
        int r=1;
 
        x%=360;

 	if (x>180) { x-=180; r=-1; }

	return r*(8100-(90-x)*(90-x))/253;
    }

    BoxCanvas()
    {
    }

    public void paint(Graphics gg)
    {
        int width = getWidth();
        int height = getHeight();
	int j,k,l, x,y,z, si, ci, sai, cai;
	String T;
	DirectGraphics dg,dgg;
	Graphics g=mirror.getGraphics();

	if ((fp_time_start==0)||(i<10)) {
	    g.setColor(0,0,0);
	    g.fillRect(0,0,127,127);

	    gg.setColor(0,0,0);
	    gg.fillRect(0,0,127,127);
	    gg.setColor(0xFF,0xFF,0xFF);
	    gg.drawString("Part 2",40,60,0);
	    i++;
	    return;
	}

	dg = DirectUtils.getDirectGraphics(g);
	dgg = DirectUtils.getDirectGraphics(gg);

	if (stop>0) {
	    if ((stop&3)!=0) {
	        dgg.fillTriangle(0,0,128,128,0,128,0x10000000);
	        dgg.fillTriangle(0,0,128,128,128,0,0x10000000);
	    }
	    stop++;
	    return;
	}


        g.setColor(0,0,0);
        g.fillRect(0,0,48,127);

	if (i++>1000) stop=1;

	alpha+=sin(4*i)/4;
	si=sin(alpha/2); ci=sin((alpha/2)+90);
	if (i<70) alpha+=4;

	z=160-2*i-4*sin(i); if (z<64) z=64;

	for( j=0; j<pt_count; j++) {
	    k=3*j+1;
	    pxy[4*j+1]=z+((points[k+1]*si+points[k]*ci)>>6);
	    pxy[4*j+2]=128+((points[k+1]*ci-points[k]*si)>>5);
	}

	g.drawImage( eye, pxy[353*4]-8, pxy[353*4+1]-8,Graphics.TOP | Graphics.LEFT );

 	for( j=k=0; j<tr_count; j++) {  	    
	    x=trian[k++]; y=trian[k++]; z=trian[k++];
	    dg.fillTriangle( pxy[x++], pxy[x++],
			     pxy[y++], pxy[y],
			     pxy[z++], pxy[z], ((pxy[x])<<24) +0xFFCF30 );
	}
	gg.drawImage( mirror, 64,0,Graphics.TOP | Graphics.LEFT);
	dgg.drawImage( mirror, 16,0,0,0x2000);
	gg.setColor(255,255,255);
        fp_time=100000*++fps/(System.currentTimeMillis()-fp_time_start);
	T=String.valueOf(fp_time);
        gg.drawString("fps="+fp_time/100+"."+fp_time%100,35,111,0);
    }

    public synchronized void start(testMIDlet papa)
    {
	int i,j,k;
	Graphics g=eye.getGraphics();
        InputStream IStr;
	byte b[]={0};

	for( i=0; i<8; i++)
	    for( j=0; j<8; j++) {
		k=130-(i*i+j*j)*2;
		if (k<0) k=0;
		g.setColor( (k*3)/2,k,k);
		g.drawLine ( 7-i,7-j,7-i,7-j);
		g.drawLine ( 8-i,8+j,7-i,8+j);
		g.drawLine ( 9+i,7-j,8+i,7-j);
		g.drawLine ( 9+i,8+j,8+i,8+j);
	    }
	g.setColor( 0xFF,0,0);
	g.drawLine ( 8,8,7,8);

  	father=papa;

	IStr= getClass().getResourceAsStream("pts.dat");
	for(i=0;i<1441;i++) {
	    try { IStr.read(b); } catch (IOException e) { break; }
	    points[i]=(int) (b[0]);
	}
	IStr= getClass().getResourceAsStream("tri.dat");
	for(i=0;i<600*3;i++) {
	    try { IStr.read(b); } catch (IOException e) { break; }
	    j=b[0]; 
	    try { IStr.read(b); } catch (IOException e) { break; }
	    k=b[0]; if (k<0) k=256+k;
	    trian[i]=j*256+k;
	}



	for( j=0; j<pt_count; j++) 
	    pxy[4*j]=points[3*j];

	for(i=0;i<tr_count*3;i++) 
	    trian[i]*=4;

        font = Font.getFont(Font.FACE_PROPORTIONAL,
                            Font.STYLE_PLAIN,
                            Font.SIZE_SMALL);
        animationThread = new Thread(this);
        animationThread.start();
        fp_time_start=System.currentTimeMillis()-1;

    }


    public void run()
    {
        Thread currentThread = Thread.currentThread();

        try
        {
            while (currentThread == animationThread)
            {
                long startTime = System.currentTimeMillis();
                //tickBoids();
                repaint(0, 0, getWidth(), getHeight());
                serviceRepaints();
                long timeTaken = System.currentTimeMillis() - startTime;
                if (timeTaken < 1)
                {
                    synchronized (this)
                    {
                        wait(1 - timeTaken);
                    }
                }
                else
                {
                    currentThread.yield();
                }
		if (stop>25) {
		    mirror=null;
		    eye=null;
		    points=null;
		    trian=null;
		    pxy=null;
		    father.nextcanvas();
		    return;
		}
            }
        }
        catch (InterruptedException e)
        {
        }
    }

    public void keyPressed(int keyCode)
    {
	if (keyCode=='5')
	   stop=1;
    }

    public void commandAction(Command c, Displayable d)
    { //have to be with keyPressed.
    }

    public synchronized void stop()
    {
        animationThread = null;
    }

}