import com.nokia.mid.ui.*;
import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import java.io.IOException;

class WarpCanvas
    extends FullCanvas
    implements Runnable, CommandListener
{
    private volatile Thread animationThread = null;
    private Font font;
    private testMIDlet papa;
    testMIDlet father;
    private Image iml[];
    int fps=0;
    long fp_time_start,fp_time;
    int i = 93, stop=0;

    private int sin(int x)
    {
        int r=1;
 
        x%=360;

 	if (x>180) { x-=180; r=-1; }

	return r*(8100-(90-x)*(90-x))/253;
    }


    WarpCanvas(testMIDlet papa)
    {
	this.papa=papa;
    }

    public void paint(Graphics g)
    {
        int width = getWidth();
        int height = getHeight();
	int j,k,l;
	String T;

        g.setColor(0,0,0);
        g.fillRect(0,0,127,127);

        g.setColor(128,0,0);
	g.drawString("by Jakub Trznadel", 6,11-stop,0);	
        g.setColor(0,0,0);
	g.drawString("by Jakub Trznadel", 7,12-stop,0);	


	if (stop==0) {
  	    for( j=0; j<9; j++)
  	        for( k=0; k<9; k++) {
		    l=i+j+k;
		     g.drawImage( iml[l%64], 28+j*8+sin( 16*l)/2, 26+k*8+sin( (l-k-k)*16+100)/2, Graphics.TOP | Graphics.LEFT);
		}
        } else {
  	    for( j=0; j<9; j++)
  	        for( k=0; k<9; k++) {
		    l=i+j+k;
		    g.drawImage( iml[l%64], 28+j*(8+stop)+sin( 16*l)/2, 26+k*(8+stop)+sin( (l-k-k)*16+100)/2, Graphics.TOP | Graphics.LEFT);
		}
	    stop++;
	}

	i++;
	if (i>1000) stop=1;

	g.setColor(255,255,255);
        fp_time=10000*++fps/(System.currentTimeMillis()-fp_time_start);
	T=String.valueOf(fp_time);
        g.drawString(T,105,101,0);
    }

    public synchronized void start(testMIDlet papa)
    {
	int i,j,l,k, r, g, b;
 	Graphics gTo;
	
	iml=new Image[64];

  	father=papa;
        fp_time_start=System.currentTimeMillis()-1;

        animationThread = new Thread(this);
        animationThread.start();
        font = Font.getFont(Font.FACE_PROPORTIONAL,
                            Font.STYLE_PLAIN,
                            Font.SIZE_SMALL);
	for(i=0; i<64; i++) {
	    iml[i]=Image.createImage(8,8);
            gTo=iml[i].getGraphics();
	    r=g=b=0;
	    for(j=0; j<8;j++)
	        for(l=0; l<8;l++) {
		    k= (4-l)*(4-l) + (4-j)*(4-j);
		    k=32-k;
		    k=k*3*i/4;
		    if (k<256)  { r=0; g=0; b=k; } else
		    if (k<512)  { r=0; g=(k-256)/2; b=255; } else
		    if (k<768)  { r=0; g=(767-k)/2; b=255; } else
		    if (k<1024) { r=0; g=0; b=1023-k; }
		    gTo.setColor(r,g,b);
		    gTo.drawLine(j,l ,j,l);
		}
	}
    }


    public void run()
    {
        Thread currentThread = Thread.currentThread();

        try
        {
            // This ends when animationThread is set to null, or when
            // it is subsequently set to a new thread; either way, the
            // current thread should terminate
            while (currentThread == animationThread)
            {
                long startTime = System.currentTimeMillis();
                //tickBoids();
                repaint(0, 0, getWidth(), getHeight());
                serviceRepaints();
                long timeTaken = System.currentTimeMillis() - startTime;
                if (timeTaken < 1)
                {
                    synchronized (this)
                    {
                        wait(1 - timeTaken);
                    }
                }
                else
                {
                    currentThread.yield();
                }
		if (stop>20) {
		    iml=null;
		    father.nextcanvas();
		    return;
		}
            }
        }
        catch (InterruptedException e)
        {
        }
    }

    public void keyPressed(int keyCode)
    {
	if (keyCode=='5')
	   stop=1;
    }

    public void commandAction(Command c, Displayable d)
    { //have to be with keyPressed.
    }

    public synchronized void stop()
    {
        animationThread = null;
    }
}
